from __future__ import absolute_import

import os
import re

from agent.tasks.service import linux
from common.utils import linuxutil
from common.utils import subprocess2

UpdateRcdCmd = subprocess2.new_command("UpdateRcdCmd", binary="/usr/sbin/update-rc.d")


class DebianServiceProvider(linux.LinuxServiceProvider):
    def set_service_enabled(self, name, enabled):
        action = "defaults" if enabled else "remove"
        cmd = UpdateRcdCmd().args("-f", name, action)
        cmd.check_output()

    def get_service_enabled(self, name):
        file_list = os.listdir("/etc/rc{}.d".format(linuxutil.runlevel()))
        regex = r"[SK][0-9]{2}%s$" % re.escape(name)
        return any(re.match(regex, x) for x in file_list)
