import importlib
import sys


def import_attr(import_str):
    """Returns a class from a string including module and class"""
    mod_str, class_str = import_str.rsplit(".", 1)
    try:
        module = importlib.import_module(mod_str)
    except ImportError:
        pass
    else:
        try:
            return getattr(module, class_str)
        except (ValueError, AttributeError):
            pass
    raise ImportError("Class {0!r} cannot be found".format(import_str))


def import_object(import_str, *args, **kwds):
    """Returns an object including a module or module and class"""
    try:
        __import__(import_str)
        return sys.modules[import_str]
    except ImportError:
        cls = import_attr(import_str)
        return cls(*args, **kwds)
