"""
Module contains all linux-related wrappers ahd helpers, which are
divided into logical modules and autoloaded into linuxutil itself

Use it like this:

from common.utils import linuxutil
linuxutil.sync()
linuxutil.mount()

"""

import sys

if sys.platform != "win32":
    from common.utils.linuxutil._fsutil import *
    from common.utils.linuxutil._misc import *
    from common.utils.linuxutil._ramdisk import *
    from common.utils.linuxutil._systemd import *
else:
    raise ImportError("Not available on Windows")
