"""
Created on Mar 2, 2011

@author: spike
"""
__all__ = ["create_ramdisk", "destroy_ramdisk"]

import os

from common.utils import subprocess2


def create_ramdisk(size, mpoint):
    from common.utils import linuxutil

    if not os.path.exists(mpoint):
        os.makedirs(mpoint)
    mount_cmd = linuxutil.MountCmd()
    mount_cmd.args("-t", "tmpfs", "-o", "size={0}M".format(size), "tmpfs", mpoint)
    subprocess2.check_call(mount_cmd.build())


def destroy_ramdisk(mpoint):
    from common.utils import linuxutil

    if not os.path.ismount(mpoint):
        raise Exception("Directory %s is not valid mount point" % mpoint)

    linuxutil.umount(mpoint)
