from scalarizr.adm.command import Command
from agent.scalarizr import msg


class FireEvent(Command):
    """
    Fires event with given name and parameters on Scalr. Parameters should be
    passed in <key>=<value> form.

    Usage:
      fire-event <name> [<kv>...]
    """

    def __call__(self, name=None, kv=None):
        kv = kv or {}
        params = dict(pair.split('=') for pair in kv if '=' in pair)

        if name == 'InitFailed':
            body = params
            message_name = name
        else:
            body = {'event_name': name, 'params': params}
            message_name = 'FireEvent'

        print('Sending %s' % name)
        msg.send(msg.create(message_name, body))
        print("Done")


commands = [FireEvent]
