import prettytable
import sys
import os


def make_table(data_rows, header=None):
    """Returns PrettyTable object applicable to print"""
    if not data_rows:
        data_rows = [[]]
    max_row_length = len(header) if header else max(map(len, data_rows))
    table = prettytable.PrettyTable(header if header else range(max_row_length))
    table.header = bool(header)

    for row in data_rows:
        if not row:
            row = []
        row_length = len(row)
        if row_length > 0:
            if row_length != max_row_length:
                row = (row + [None]*max_row_length)[:max_row_length]
            table.add_row(row)

    return table
