"""
.. module:: ansible
   :platform: Linux/Windows
   :synopsis: API methods for managing Ansible Tower integration.
.. moduleauthor:: Marat Komarov <marat@scalr.com>
"""
from __future__ import absolute_import

from scalarizr.util import Singleton
from agent.scalarizr.hub import hub
from agent.scalarizr import base
from agent.scalarizr import rpc


class AnsibleAPI(metaclass=Singleton):
    """Implements 'ansible' JSONRPC namespace.
    """

    @rpc.command_method
    def provision_host(self):
        """Implements 'ansible.provision_host' JSONRPC call.
        """
        hub.sync()
        return base.provision_ansible_host()
