import logging

from common.utils import subprocess2
from common.utils.facts import fact
from scalarizr.api import image


LOG = logging.getLogger(__name__)


class AzureImageAPIDelegate(image.ImageAPIDelegate):
    def prepare(self, op, name):
        if fact['os']['family'] != 'windows':
            LOG.info('Deprovisioning VM with waagent')
            subprocess2.check_output_host('waagent -deprovision+user -force', shell=True)
        else:
            LOG.info('Generalizing VM with sysprep')
            subprocess2.check_output(
                ('C:\\Windows\\system32\\sysprep\\sysprep.exe'
                 ' /generalize /oobe /shutdown /quiet /mode:vm'),
                shell=True)

    def snapshot(self, op, name):
        pass

    def finalize(self, op, name):
        pass
