'''
Created on Mar 2, 2010

@author: marat
'''

import os
import re
import sys
import logging

from agent.scalarizr.hub import hub

import scalarizr
from scalarizr.handlers import Handler


def get_handlers():
    return [Ec2LifeCycleHandler()]


class Ec2LifeCycleHandler(Handler):
    _logger = None
    _platform = None
    """
    @ivar scalarizr.platform.ec2.Ec2Platform:
    """

    def __init__(self):
        self._logger = logging.getLogger(__name__)
        hub.on(init=self.on_init)

    def on_init(self, *args, **kwargs):
        hub.on("before_hello", self.on_before_hello)
        hub.on("before_host_init", self.on_before_host_init)
        hub.on("before_restart", self.on_before_restart)


    def on_before_hello(self, message):
        """
        @param message: Hello message
        """

        message.aws_instance_id = hub.platform.get_instance_id()
        message.aws_instance_type = hub.platform.get_instance_type()
        message.aws_ami_id = hub.platform.get_ami_id()
        message.aws_avail_zone = hub.platform.get_avail_zone()


    def on_before_host_init(self, message):
        """
        @param message: HostInit message
        """

        message.ssh_pub_key = hub.platform.get_ssh_pub_key()

    def on_before_restart(self, message):
        """
        @param message: Restart message
        @type message: scalarizr.messaging.Message
        """

        """
        @todo Update ips, reset platform meta-data
        @see http://docs.amazonwebservices.com/AWSEC2/latest/DeveloperGuide/index.html?Concepts_BootFromEBS.html#Stop_Start
        """
        pass

    def on_before_message_send(self, queue, message):
        """
        @todo: add aws specific here
        """

        pass
