'''
Created on Mar 11, 2010
@author: marat

IMPORTANT: Rebundle of non-HVM ec2-instances is deprecated.
'''

import logging
import os
import platform

from scalarizr import linux
from scalarizr.handlers import Handler
from scalarizr.handlers import rebundle as rebundle_hdlr
from scalarizr.handlers import Messages
from scalarizr.libs.metaconf import Configuration


def get_handlers():
    return [Ec2RebundleWindowsHandler()] if linux.os.windows_family else []

LOG = rebundle_hdlr.LOG


class Ec2RebundleWindowsHandler(Handler):
    logger = None

    def __init__(self):
        self._logger = logging.getLogger(__name__)

    def accept(self, message, queue, behaviour=None, platform=None, os=None, dist=None):
        return message.name == Messages.WIN_PREPARE_BUNDLE

    def on_Win_PrepareBundle(self, message):
        # deprecated since 2015/08/04
        try:
            """
            cmd = ('ec2config.exe -sysprep')
            sysprep = Popen(cmd)
            ret = sysprep.wait()
            if ret:
                raise HandlerError('Ec2config finished with return code %s' % ret)
            """
            ec2config_cnf_path = 'C:\\Program Files\\Amazon\\Ec2ConfigService\\Settings\\config.xml'
            if os.path.exists(ec2config_cnf_path):
                ec2_conf = Configuration('xml')
                ec2_conf.read(ec2config_cnf_path)
                i = 1
                while True:
                    try:
                        opt_name = ec2_conf.get('./Ec2ConfigurationSettings/Plugins/Plugin[%s]/Name' % i)
                        if opt_name in ('Ec2SetPassword', 'Ec2SetComputerName'):
                            ec2_conf.set('./Ec2ConfigurationSettings/Plugins/Plugin[%s]/State' % i, 'Enabled')
                        i += 1
                    except:
                        break

                ec2_conf.write(ec2config_cnf_path)

            os_info = {}
            uname = platform.uname()
            os_info['version'] = uname[2]
            os_info['string_version'] = ' '.join(uname).strip()

            self.send_message(Messages.WIN_PREPARE_BUNDLE_RESULT, dict(
                status="ok",
                bundle_task_id=message.bundle_task_id,
                os=os_info
            ))

        except (Exception, BaseException) as e:
            self._logger.exception(e)
            last_error = hasattr(e, "error_message") and e.error_message or str(e)
            self.send_message(Messages.WIN_PREPARE_BUNDLE_RESULT, dict(
                status="error",
                last_error=last_error,
                bundle_task_id=message.bundle_task_id
            ))
