import os
import logging

from scalarizr.handlers import Handler
from scalarizr.handlers import Messages
from common.utils import sysutil
from common.utils import facts
from agent.scalarizr.base import update_ssh_authorized_keys


LOG = logging.getLogger(__name__)


def get_handlers():
    if facts.WINDOWS:
        return []
    else:
        return [SSHKeys()]


class SSHKeys(Handler):

    def on_UpdateSshAuthorizedKeys(self, message):
        update_ssh_authorized_keys(
            keys_to_add=message.add, keys_to_remove=message.remove, update_all_users=True)

    def accept(self, message, queue, behaviour=None, platform=None, os=None, dist=None):
        return message.name == Messages.UPDATE_SSH_AUTHORIZED_KEYS

