'''
Created on Mar 1, 2010

@author: marat
'''


import logging
import os

from agent.scalarizr import msg
from agent.scalarizr import app
from agent.scalarizr.hub import hub
from agent.tasks import service
from common.utils import mixutil

@mixutil.error_logged('Error in udev script', reraise=False)
def main():
    app.prepare()
    logger = logging.getLogger('scalarizr.scripts.udev')
    logger.debug('Starting udev script...')
    if service.Service('scalarizr').running:
        msg.send(
            msg.create('IntBlockDeviceUpdated',
                       body={k.lower(): v for k, v in os.environ.items()}),
            endpoint='http://0.0.0.0:{}'.format(hub.base.messaging_port))
    else:
        logger.debug(
            "Don't fire internal IntBlockDeviceUpdated, "
            "cause Scalarizr service is not running")
